# Copyright 2023 Ekumen, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# cmake-lint: disable=C0111,C0103
# Missing docstring on function or macro declaration
# Invalid local variable name "EXECUTABLE" doesn't match `[a-z][a-z0-9_]+`
# Invalid local variable name "NODELETS" doesn't match `[a-z][a-z0-9_]+`
function(add_nodelet_executable target)
  set(EXECUTABLE ${target})
  if(ARGC LESS 2)
    message(FATAL_ERROR "No nodelets specified for ${target} executable.")
  endif()

  string(
    REPLACE ";"
            "\",\""
            NODELETS
            "${ARGN}")
  set(NODELETS "\"${NODELETS}\"")

  configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/lib/templates/nodelet_executable_main.cpp.in
    ${PROJECT_BINARY_DIR}/${target}_main.cpp.in @ONLY)
  file(
    GENERATE
    OUTPUT ${PROJECT_BINARY_DIR}/${target}_main.cpp
    INPUT ${PROJECT_BINARY_DIR}/${target}_main.cpp.in)
  add_executable(${target} ${PROJECT_BINARY_DIR}/${target}_main.cpp)
  target_link_libraries(${target} ${catkin_LIBRARIES})
endfunction()
